std::wbuffer_convert< _Codecvt, _Elem, _Tr >(3)

NAME
std::wbuffer_convert< _Codecvt, _Elem, _Tr > - Buffer conversions.

SYNOPSIS

Inherits std::basic_streambuf< _Elem, _Tr >.

  Public Types
typedef _Codecvt::state_type state_type

typedef _Elem char_type
typedef _Tr traits_type
typedef traits_type::int_type int_type
typedef traits_type::pos_type pos_type
typedef traits_type::off_type off_type

typedef basic_streambuf< char_type, traits_type > __streambuf_type
This is a non-standard type.

  Public Member Functions
wbuffer_convert (streambuf *__bytebuf=0, _Codecvt *__pcvt=new _Codecvt, state_type __state=state_type())
wbuffer_convert (const wbuffer_convert &)=delete
locale getloc () const
Locale access.
streamsize in_avail ()
Looking ahead into the stream.
wbuffer_convert & operator= (const wbuffer_convert &)=delete
locale pubimbue (const locale &__loc)
Entry point for imbue().
streambuf * rdbuf () const noexcept
streambuf * rdbuf (streambuf *__bytebuf) noexcept
int_type sbumpc ()
Getting the next character.
int_type sgetc ()
Getting the next character.
streamsize sgetn (char_type *__s, streamsize __n)
Entry point for xsgetn.
int_type snextc ()
Getting the next character.
int_type sputbackc (char_type __c)
Pushing characters back into the input stream.
int_type sputc (char_type __c)
Entry point for all single-character output functions.
streamsize sputn (const char_type *__s, streamsize __n)
Entry point for all single-character output functions.
state_type state () const noexcept
The conversion state following the last conversion.
int_type sungetc ()
Moving backwards in the input stream.

basic_streambuf * pubsetbuf (char_type *__s, streamsize __n)
Entry points for derived buffer functions.
pos_type pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
Alters the stream position.
pos_type pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
Alters the stream position.
int pubsync ()
Calls virtual sync function.

  Protected Member Functions
void __safe_gbump (streamsize __n)
void __safe_pbump (streamsize __n)
void gbump (int __n)
Moving the read position.
virtual void imbue (const locale &__loc)
Changes translations.
_Wide_streambuf::int_type overflow (typename _Wide_streambuf::int_type __out)
Consumes data from the buffer; writes to the controlled sequence.
virtual int_type pbackfail (int_type __c=traits_type::eof())
Tries to back up the input sequence.
void pbump (int __n)
Moving the write position.
virtual pos_type seekoff (off_type, ios_base::seekdir, ios_base::openmode=ios_base::in|ios_base::out)
Alters the stream positions.
virtual pos_type seekpos (pos_type, ios_base::openmode=ios_base::in|ios_base::out)
Alters the stream positions.
virtual basic_streambuf< char_type, _Tr > * setbuf (char_type *, streamsize)
Manipulates the buffer.
void setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
Setting the three read area pointers.
void setp (char_type *__pbeg, char_type *__pend)
Setting the three write area pointers.
virtual streamsize showmanyc ()
Investigating the data available.
void swap (basic_streambuf &__sb)
int sync ()
Synchronizes the buffer arrays with the controlled sequences.
virtual int_type uflow ()
Fetches more data from the controlled sequence.
_Wide_streambuf::int_type underflow ()
Fetches more data from the controlled sequence.
virtual streamsize xsgetn (char_type *__s, streamsize __n)
Multiple character extraction.
streamsize xsputn (const typename _Wide_streambuf::char_type *__s, streamsize __n)
virtual streamsize xsputn (const char_type *__s, streamsize __n)
Multiple character insertion.

char_type * eback () const
Access to the get area.
char_type * gptr () const
Access to the get area.
char_type * egptr () const
Access to the get area.

char_type * pbase () const
Access to the put area.
char_type * pptr () const
Access to the put area.
char_type * epptr () const
Access to the put area.

  Protected Attributes
locale _M_buf_locale
Current locale setting.
char_type * _M_in_beg
Start of get area.
char_type * _M_in_cur
Current read area.
char_type * _M_in_end
End of get area.
char_type * _M_out_beg
Start of put area.
char_type * _M_out_cur
Current put area.
char_type * _M_out_end
End of put area.

Detailed Description

  template<typename _Codecvt, typename _Elem = wchar_t, typename _Tr = char_traits<_Elem>>
class std::wbuffer_convert< _Codecvt, _Elem, _Tr >" Buffer conversions.

Definition at line 318 of file locale_conv.h.

Member Typedef Documentation

  typedef basic_streambuf<char_type, traits_type> std::basic_streambuf< _Elem , _Tr >::__streambuf_type [inherited]

This is a non-standard type.

Definition at line 138 of file streambuf.

  typedef _Elem std::basic_streambuf< _Elem , _Tr >::char_type [inherited]
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 129 of file streambuf.

  typedef traits_type::int_type std::basic_streambuf< _Elem , _Tr >::int_type [inherited]
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 131 of file streambuf.

  typedef traits_type::off_type std::basic_streambuf< _Elem , _Tr >::off_type [inherited]
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 133 of file streambuf.

  typedef traits_type::pos_type std::basic_streambuf< _Elem , _Tr >::pos_type [inherited]
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 132 of file streambuf.

  typedef _Tr std::basic_streambuf< _Elem , _Tr >::traits_type [inherited]
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 130 of file streambuf.

Constructor & Destructor Documentation

  template<typename _Codecvt , typename _Elem = wchar_t, typename _Tr = char_traits<_Elem>> std::wbuffer_convert< _Codecvt, _Elem, _Tr >::wbuffer_convert (streambuf * __bytebuf = 0, _Codecvt * __pcvt = new _Codecvt, state_type __state = state_type()) [inline], [explicit]
Default constructor.

Parameters:
    __bytebuf The underlying byte stream buffer.
    __pcvt The facet to use for conversions.
    __state Initial conversion state.

Takes ownership of __pcvt and will delete it in the destructor.

Definition at line 334 of file locale_conv.h.

Member Function Documentation

  char_type* std::basic_streambuf< _Elem , _Tr >::eback () const [inline], [protected], [inherited]

Access to the get area. These functions are only available to other protected functions, including derived classes.

•   eback() returns the beginning pointer for the input sequence

•   gptr() returns the next pointer for the input sequence

•   egptr() returns the end pointer for the input sequence

Definition at line 482 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::_M_in_beg.

  char_type* std::basic_streambuf< _Elem , _Tr >::egptr () const [inline], [protected], [inherited]

Access to the get area. These functions are only available to other protected functions, including derived classes.

•   eback() returns the beginning pointer for the input sequence

•   gptr() returns the next pointer for the input sequence

•   egptr() returns the end pointer for the input sequence

Definition at line 488 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::_M_in_end.

  char_type* std::basic_streambuf< _Elem , _Tr >::epptr () const [inline], [protected], [inherited]

Access to the put area. These functions are only available to other protected functions, including derived classes.

•   pbase() returns the beginning pointer for the output sequence

•   pptr() returns the next pointer for the output sequence

•   epptr() returns the end pointer for the output sequence

Definition at line 535 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::_M_out_end.

  void std::basic_streambuf< _Elem , _Tr >::gbump (int __n) [inline], [protected], [inherited]

Moving the read position.

Parameters:
    __n The delta by which to move.

This just advances the read position without returning any data.

Definition at line 498 of file streambuf.

  locale std::basic_streambuf< _Elem , _Tr >::getloc () const [inline], [inherited]

Locale access.

Returns:
    The current locale in effect.

If pubimbue(loc) has been called, then the most recent loc is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 226 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::_M_buf_locale.

  char_type* std::basic_streambuf< _Elem , _Tr >::gptr () const [inline], [protected], [inherited]

Access to the get area. These functions are only available to other protected functions, including derived classes.

•   eback() returns the beginning pointer for the input sequence

•   gptr() returns the next pointer for the input sequence

•   egptr() returns the end pointer for the input sequence

Definition at line 485 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::_M_in_cur.

  virtual void std::basic_streambuf< _Elem , _Tr >::imbue (const locale & __loc) [inline], [protected], [virtual], [inherited]

Changes translations.

Parameters:
    __loc A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained.

Note:
    Base class version does nothing.

Definition at line 576 of file streambuf.

  streamsize std::basic_streambuf< _Elem , _Tr >::in_avail () [inline], [inherited]

Looking ahead into the stream.

Returns:
    The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived showmanyc().

Definition at line 284 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::egptr(), std::basic_streambuf< _CharT, _Traits >::gptr(), and std::basic_streambuf< _CharT, _Traits >::showmanyc().

  template<typename _Codecvt , typename _Elem = wchar_t, typename _Tr = char_traits<_Elem>> _Wide_streambuf::int_type std::wbuffer_convert< _Codecvt, _Elem, _Tr >::overflow (typename _Wide_streambuf::int_type __c) [inline], [protected], [virtual]

Consumes data from the buffer; writes to the controlled sequence.

Parameters:
    __c An additional character to consume.

Returns:
    eof() to indicate failure, something else (usually __c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is consumed, with some effect on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if __c is not eof().

For a formal definition of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note:
    Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _Elem, _Tr >.

Definition at line 378 of file locale_conv.h.

  virtual int_type std::basic_streambuf< _Elem , _Tr >::pbackfail (int_type __c = traits_type::eof()) [inline], [protected], [virtual], [inherited]

Tries to back up the input sequence.

Parameters:
    __c The character to be inserted back into the sequence.

Returns:
    eof() on failure, some other value on success

Postcondition:
    The constraints of gptr(), eback(), and pptr() are the same as for underflow().

Note:
    Base class version does nothing, returns eof().

Definition at line 724 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::xsputn().

  char_type* std::basic_streambuf< _Elem , _Tr >::pbase () const [inline], [protected], [inherited]

Access to the put area. These functions are only available to other protected functions, including derived classes.

•   pbase() returns the beginning pointer for the output sequence

•   pptr() returns the next pointer for the output sequence

•   epptr() returns the end pointer for the output sequence

Definition at line 529 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::_M_out_beg.

  void std::basic_streambuf< _Elem , _Tr >::pbump (int __n) [inline], [protected], [inherited]

Moving the write position.

Parameters:
    __n The delta by which to move.

This just advances the write position without returning any data.

Definition at line 545 of file streambuf.

  char_type* std::basic_streambuf< _Elem , _Tr >::pptr () const [inline], [protected], [inherited]

Access to the put area. These functions are only available to other protected functions, including derived classes.

•   pbase() returns the beginning pointer for the output sequence

•   pptr() returns the next pointer for the output sequence

•   epptr() returns the end pointer for the output sequence

Definition at line 532 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::_M_out_cur.

  locale std::basic_streambuf< _Elem , _Tr >::pubimbue (const locale & __loc) [inline], [inherited]

Entry point for imbue().

Parameters:
    __loc The new locale.

Returns:
    The previous locale.

Calls the derived imbue(__loc).

Definition at line 209 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::getloc(), and std::basic_streambuf< _CharT, _Traits >::imbue().

  pos_type std::basic_streambuf< _Elem , _Tr >::pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode = ios_base::in | ios_base::out) [inline], [inherited]

Alters the stream position.

Parameters:
    __off Offset.
    __way Value for ios_base::seekdir.
    __mode Value for ios_base::openmode.

Calls virtual seekoff function.

Definition at line 251 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::seekoff().

  pos_type std::basic_streambuf< _Elem , _Tr >::pubseekpos (pos_type __sp, ios_base::openmode __mode = ios_base::in | ios_base::out) [inline], [inherited]

Alters the stream position.

Parameters:
    __sp Position
    __mode Value for ios_base::openmode.

Calls virtual seekpos function.

Definition at line 263 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::seekpos().

  basic_streambuf* std::basic_streambuf< _Elem , _Tr >::pubsetbuf (char_type * __s, streamsize __n) [inline], [inherited]

Entry points for derived buffer functions. The public versions of pubfoo dispatch to the protected derived foo member functions, passing the arguments (if any) and returning the result unchanged.

Definition at line 239 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::setbuf().

  int std::basic_streambuf< _Elem , _Tr >::pubsync () [inline], [inherited]

Calls virtual sync function.

Definition at line 271 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::sync().

  int_type std::basic_streambuf< _Elem , _Tr >::sbumpc () [inline], [inherited]

Getting the next character.

Returns:
    The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns uflow().

Definition at line 316 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::egptr(), std::basic_streambuf< _CharT, _Traits >::gbump(), std::basic_streambuf< _CharT, _Traits >::gptr(), and std::basic_streambuf< _CharT, _Traits >::uflow().

  virtual pos_type std::basic_streambuf< _Elem , _Tr >::seekoff (off_type, ios_base::seekdir, ios_base::openmode = ios_base::in | ios_base::out) [inline], [protected], [virtual], [inherited]

Alters the stream positions. Each derived class provides its own appropriate behavior.

Note:
    Base class version does nothing, returns a pos_type that represents an invalid stream position.

Definition at line 602 of file streambuf.

  virtual pos_type std::basic_streambuf< _Elem , _Tr >::seekpos (pos_type, ios_base::openmode = ios_base::in | ios_base::out) [inline], [protected], [virtual], [inherited]

Alters the stream positions. Each derived class provides its own appropriate behavior.

Note:
    Base class version does nothing, returns a pos_type that represents an invalid stream position.

Definition at line 614 of file streambuf.

  virtual basic_streambuf<char_type,_Tr >* std::basic_streambuf< _Elem , _Tr >::setbuf (char_type *, streamsize) [inline], [protected], [virtual], [inherited]

Manipulates the buffer. Each derived class provides its own appropriate behavior. See the next-to-last paragraph of https://gcc.gnu.org/onlinedocs/libstdc++/manual/streambufs.html#io.streambuf.buffering for more on this function.

Note:
    Base class version does nothing, returns this.

Definition at line 591 of file streambuf.

  void std::basic_streambuf< _Elem , _Tr >::setg (char_type * __gbeg, char_type * __gnext, char_type * __gend) [inline], [protected], [inherited]

Setting the three read area pointers.

Parameters:
    __gbeg A pointer.
    __gnext A pointer.
    __gend A pointer.

Postcondition:
    __gbeg == eback(), __gnext == gptr(), and __gend == egptr()

Definition at line 509 of file streambuf.

  void std::basic_streambuf< _Elem , _Tr >::setp (char_type * __pbeg, char_type * __pend) [inline], [protected], [inherited]

Setting the three write area pointers.

Parameters:
    __pbeg A pointer.
    __pend A pointer.

Postcondition:
    __pbeg == pbase(), __pbeg == pptr(), and __pend == epptr()

Definition at line 555 of file streambuf.

  int_type std::basic_streambuf< _Elem , _Tr >::sgetc () [inline], [inherited]

Getting the next character.

Returns:
    The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns underflow(). Does not move the read position after fetching the character.

Definition at line 338 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::egptr(), std::basic_streambuf< _CharT, _Traits >::gptr(), and std::basic_streambuf< _CharT, _Traits >::underflow().

  streamsize std::basic_streambuf< _Elem , _Tr >::sgetn (char_type * __s, streamsize __n) [inline], [inherited]

Entry point for xsgetn.

Parameters:
    __s A buffer area.
    __n A count.

Returns xsgetn(__s,__n). The effect is to fill __s[0] through __s[__n-1] with characters from the input sequence, if possible.

Definition at line 357 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::xsgetn().

  virtual streamsize std::basic_streambuf< _Elem , _Tr >::showmanyc () [inline], [protected], [virtual], [inherited]

Investigating the data available.

Returns:
    An estimate of the number of characters available in the input sequence, or -1.

If it returns a positive value, then successive calls to underflow() will not return traits::eof() until at least that number of characters have been supplied. If showmanyc() returns -1, then calls to underflow() or uflow() will fail. [27.5.2.4.3]/1

Note:
    Base class version does nothing, returns zero.

    The standard adds that the intention is not only that the calls [to underflow or uflow] will not return eof() but that they will return immediately.

    The standard adds that the morphemes of showmanyc are es-how-many-see, not show-manic.

Definition at line 649 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::xsgetn().

  int_type std::basic_streambuf< _Elem , _Tr >::snextc () [inline], [inherited]

Getting the next character.

Returns:
    The next character, or eof.

Calls sbumpc(), and if that function returns traits::eof(), so does this function. Otherwise, sgetc().

Definition at line 298 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::sbumpc(), and std::basic_streambuf< _CharT, _Traits >::sgetc().

  int_type std::basic_streambuf< _Elem , _Tr >::sputbackc (char_type __c) [inline], [inherited]

Pushing characters back into the input stream.

Parameters:
    __c The character to push back.

Returns:
    The previous character, if possible.

Similar to sungetc(), but __c is pushed onto the stream instead of the previous character. If successful, the next character fetched from the input stream will be __c.

Definition at line 372 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::gbump(), std::basic_streambuf< _CharT, _Traits >::gptr(), and std::basic_streambuf< _CharT, _Traits >::pbackfail().

  int_type std::basic_streambuf< _Elem , _Tr >::sputc (char_type __c) [inline], [inherited]

Entry point for all single-character output functions.

Parameters:
    __c A character to output.

Returns:
    __c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores __c in that position, increments the position, and returns traits::to_int_type(__c). If a write position is not available, returns overflow(__c).

Definition at line 424 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::epptr(), std::basic_streambuf< _CharT, _Traits >::overflow(), std::basic_streambuf< _CharT, _Traits >::pbump(), and std::basic_streambuf< _CharT, _Traits >::pptr().

  streamsize std::basic_streambuf< _Elem , _Tr >::sputn (const char_type * __s, streamsize __n) [inline], [inherited]

Entry point for all single-character output functions.

Parameters:
    __s A buffer read area.
    __n A count.

One of two public output functions.

Returns xsputn(__s,__n). The effect is to write __s[0] through __s[__n-1] to the output sequence, if possible.

Definition at line 450 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::xsputn().

  template<typename _Codecvt , typename _Elem = wchar_t, typename _Tr = char_traits<_Elem>> state_type std::wbuffer_convert< _Codecvt, _Elem, _Tr >::state () const [inline], [noexcept]

The conversion state following the last conversion.

Definition at line 370 of file locale_conv.h.

  int_type std::basic_streambuf< _Elem , _Tr >::sungetc () [inline], [inherited]

Moving backwards in the input stream.

Returns:
    The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to unget the last character gotten.

Definition at line 397 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::gbump(), std::basic_streambuf< _CharT, _Traits >::gptr(), and std::basic_streambuf< _CharT, _Traits >::pbackfail().

  template<typename _Codecvt , typename _Elem = wchar_t, typename _Tr = char_traits<_Elem>> int std::wbuffer_convert< _Codecvt, _Elem, _Tr >::sync (void) [inline], [protected], [virtual]

Synchronizes the buffer arrays with the controlled sequences.

Returns:
    -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of failure.

Note:
    Base class version does nothing, returns zero.

Reimplemented from std::basic_streambuf< _Elem, _Tr >.

Definition at line 374 of file locale_conv.h.

  virtual int_type std::basic_streambuf< _Elem , _Tr >::uflow () [inline], [protected], [virtual], [inherited]

Fetches more data from the controlled sequence.

Returns:
    The first character from the pending sequence.

Informally, this function does the same thing as underflow(), and in fact is required to call that function. It also returns the new character, like underflow() does. However, this function also moves the read position forward by one.

Definition at line 700 of file streambuf.

References std::basic_streambuf< _CharT, _Traits >::gbump(), std::basic_streambuf< _CharT, _Traits >::gptr(), and std::basic_streambuf< _CharT, _Traits >::underflow().

  template<typename _Codecvt , typename _Elem = wchar_t, typename _Tr = char_traits<_Elem>> _Wide_streambuf::int_type std::wbuffer_convert< _Codecvt, _Elem, _Tr >::underflow () [inline], [protected], [virtual]

Fetches more data from the controlled sequence.

Returns:
    The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is refilled. In either case, the next available character is returned, or traits::eof() to indicate a null pending sequence.

For a formal definition of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see https://gcc.gnu.org/onlinedocs/libstdc++/manual/streambufs.html

Note:
    Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _Elem, _Tr >.

Definition at line 388 of file locale_conv.h.

References std::min().

  virtual streamsize std::basic_streambuf< _Elem , _Tr >::xsgetn (char_type * __s, streamsize __n) [protected], [virtual], [inherited]

Multiple character extraction.

Parameters:
    __s A buffer area.
    __n Maximum number of characters to assign.

Returns:
    The number of characters assigned.

Fills __s[0] through __s[__n-1] with characters from the input sequence, as if by sbumpc(). Stops when either __n characters have been copied, or when traits::eof() would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

  virtual streamsize std::basic_streambuf< _Elem , _Tr >::xsputn (const char_type * __s, streamsize __n) [protected], [virtual], [inherited]

Multiple character insertion.

Parameters:
    __s A buffer area.
    __n Maximum number of characters to write.

Returns:
    The number of characters written.

Writes __s[0] through __s[__n-1] to the output sequence, as if by sputc(). Stops when either n characters have been copied, or when sputc() would return traits::eof().

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Member Data Documentation

  locale std::basic_streambuf< _Elem , _Tr >::_M_buf_locale [protected], [inherited]

Current locale setting.

Definition at line 192 of file streambuf.

  char_type* std::basic_streambuf< _Elem , _Tr >::_M_in_beg [protected], [inherited]

Start of get area.

Definition at line 184 of file streambuf.

  char_type* std::basic_streambuf< _Elem , _Tr >::_M_in_cur [protected], [inherited]

Current read area.

Definition at line 185 of file streambuf.

  char_type* std::basic_streambuf< _Elem , _Tr >::_M_in_end [protected], [inherited]

End of get area.

Definition at line 186 of file streambuf.

  char_type* std::basic_streambuf< _Elem , _Tr >::_M_out_beg [protected], [inherited]

Start of put area.

Definition at line 187 of file streambuf.

  char_type* std::basic_streambuf< _Elem , _Tr >::_M_out_cur [protected], [inherited]

Current put area.

Definition at line 188 of file streambuf.

  char_type* std::basic_streambuf< _Elem , _Tr >::_M_out_end [protected], [inherited]

End of put area.

Definition at line 189 of file streambuf.

Author

Generated automatically by Doxygen for libstdc++ from the source code.